--- render.c	2001/11/01 20:27:38	1.5
+++ render.c	2002/06/25 22:46:21	1.9
@@ -182,16 +173,17 @@
 id3_length_t id3_render_paddedstring(id3_byte_t **ptr, id3_ucs4_t const *ucs4,
 				     id3_length_t length)
 {
-  id3_ucs4_t padded[31], *data;
+  id3_ucs4_t padded[31], *data, *end;
 
   /* latin1 encoding only (this is used for ID3v1 fields) */
 
   assert(length <= 30);
 
   data = padded;
+  end  = data + length;
 
   if (ucs4) {
-    while (*ucs4 && length--) {
+    while (*ucs4 && end - data > 0) {
       *data++ = *ucs4++;
 
       if (data[-1] == '\n')
@@ -199,7 +191,7 @@
     }
   }
 
-  while (length--)
+  while (end - data > 0)
     *data++ = ' ';
 
   *data = 0;
